<?php
// Session starten am Anfang.
session_start();

// Dateien inkludieren
include "funcs.php";

if(check_install()) {
	// Hier ist eine gute Installation
	$ausgabe_main = 'Bitte loggen Sie sich mit dem Master-Passwort ein:<br><br>
	<input type="password" id="pwd" class="eingabefeld ui-corner-all">
	<button id="senden">Einloggen</button>
	<div id="fpwd" title="Falsches Kennwort">Sie haben ein falsches Kennwort eingegeben.</div>';
	$ausgabe_heading = 'Login';
	$ausgabe_script = 'login.js';
	$ausgabe_install = ' class="ui-state-disabled"';
	
	// Bei guter Installation darf er nichts und die Session wird terminiert.
	$_SESSION["anm_ui"] = array();
	session_destroy();
}
else {
	$ausgabe_main = '<div id="error" class="ui-state-error ui-corner-all"><span class="ui-icon ui-icon-alert icon_in"></span>
	Das Anmeldesystem scheint noch nicht installiert zu sein. Bitte installieren Sie es, indem Sie auf Setup &rarr; Installieren klicken.</div>';
	$ausgabe_heading = 'Fehler';
	$ausgabe_script = 'leer.js';
	
	// Bei schlechter Installation darf er sogar etwas installieren:
	$_SESSION["anm_ui"]["allowed"] = "1";
}

?>

<html lang="de">
<head>
<title>Anmelde UserInterface</title>
<meta charset="utf-8">
<script src="js/jquery.js" type="text/javascript"></script>
<script src="js/jquery_ui.js" type="text/javascript"></script>
<script src="<?php echo $ausgabe_script; ?>" type="text/javascript"></script>
<script src="scripts.js" type="text/javascript"></script>
<link rel="stylesheet" href="js/jquery_ui.css" type="text/css">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
<div id="head">
<div style="float: left;">
<button id="nu0">Home</button>
<button id="nu1">Setup</button>
<button id="nu2">Benutzer</button>
<button id="nu3">Anmeldungsansicht</button>
</div>

<h3 style="text-align: right; margin: 0px 15px;">T&Uuml; Anmeldesystem | <span id="heading"><?php echo $ausgabe_heading; ?></span></h3>

<ul id="menu0">
<li><a href="../">Startseite</a></li>
<li><a href="#" onclick="change_page('startseite');">Startseite UI</a></li>
</ul>

<ul id="menu1">
<li<?php echo $ausgabe_install; ?>><a href="#" onclick="change_page('install')">Installieren</a>
<ul><li<?php echo $ausgabe_install; ?>><a href="#" onclick="change_page('check_installation')">Installation &uuml;berpr&uuml;fen</a></li></ul></li>
<li class="ui-state-disabled"><a href="#" onclick="change_page('manual')">Bedienungsanleitung</a></li>
</ul>

<ul id="menu2">
<li><a href="index.php">Login / Logout</a></li>
<li class="ui-state-disabled"><a href="#" onclick="change_page('password')">Passwort &auml;ndern</a></li>
</ul>

<ul id="menu3">
<li class="ui-state-disabled"><a href="#" onclick="change_page('familien')">Familiengruppen</a></li>
<li class="ui-state-disabled"><a href="#" onclick="change_page('teilnehmer')">Teilnehmer</a></li>
</ul>
</div>
<br>

<div id="body" class="ui-corner-all">
<?php echo $ausgabe_main;?>
</div>

<div id="window"></div>
<div id="berechtigung" title="Fehler">Sie haben hierf&uuml;r keine Berechtigung!</div>

<br><br>
<center><span style="font-size: 8pt; color: #A0A0A0;">T&Uuml; Anmeldesystem | Anmelde UI<br>Version 1.0.1</span></center>
</body>
</html>