<?php
session_start();
include "funcs.php";

// Wenn es eine gute Installation gibt, dann wird auch die MySQL_inc inkludiert:
if (check_install())
	require_once "../mysql_inc.php";

/*
Syntax fuer Absendungen:
TITEL%!%SCRIPTEINBINDUNG%!%INHALT%!%STARTUPFUNCTION[1/0]{designit}
*/

// Die Gets empfangen
$seite = $_POST["seite"];
if ($_SESSION["anm_ui"]["allowed"] != "")
	$session = $_SESSION["anm_ui"]["allowed"];
else
	$session = "0";

// Alle erlaubten Funktionen (0=Gast;1=Installation;2=Alles)
$allowed = array(
"0" => array("startseite", "login"),
"1" => array("startseite", "install", "check_installation"),
"2" => array("startseite", "install", "teilnehmer", "teilnehmer_paid", "teilnehmer_sign",
"teilnehmer_notice", "teilnehmer_remove", "password", "manual", "familien", "familien_teilnehmer",
"check_installation")
);

if (in_array($seite, $allowed[$session]))
	call_user_func($seite, "");
else
	echo 'error_f';


/*
--------------------------------FUNKTIONEN------------------------------
*/

function install () {
	
	// Headinformationen ausgeben
	echo 'Installationsassistent%!%install.js%!%';
	
	// Wenn Installation bereits gut gelaufen, dann gibt es keine Installation:
	if (check_install())
		echo '<div id="highlight" class="ui-state-highlight ui-corner-all"><span class="ui-icon ui-icon-info icon_in"></span>' .
		'Das System ist bereits installiert.</div>';
	
	else {
		
		
		
	}
	
}

function check_installation () {
	global $verbindung;
	/*
	Der vollstaendige Check beinhaltet:
	Ordner: Alle Ordner vorhanden
	Dateien: Alle Dateien vom gesamten System (Anm & Anm_UI) vorhanden
	Keine Dateien vorhanden, die nicht da sein duerften --> Ausser Root!
	Alle Dateien lesbar (Berechtigung)
	MySQL Verbindung funktioniert & mysql_data.php vorhanden
	MySQL alle Tabellen vorhanden
	MySQL Systemtabelle beschrieben mit ID 1 & existent & die einzige
	Systemtabelle entsperrt und Passwort gesetzt (Register) -> Fehlerhaft, wenn Test zuvor auch fehlerhaft.
	*/
	
	// Angeben, was alles vorhanden sein muss:
	
	//Ordnerliste
	$check_ordner = array("../img", "../downloads", "../js", "js", "js/images", "imgs");
	
	// Dateienliste
	$check_dateien = array("../index.php", "../functions_inc.php", "../mysql_inc.php", "../oof_inc.php", "../styles.css", "../data_inc.php",
	"../downloads/anleitung.pdf", "../downloads/tu_2013_ablauf.pdf", "../downloads/tu_2013_flyer.pdf", "../downloads/index.html",
	"../downloads/anleitung_administration.pdf",
	"../img/absatz.jpg", "../img/bg.jpg", "../img/ecke.jpg", "../img/email.jpg", "../img/pixel.gif", "../img/index.html",
	"../js/gemeindeverzeichnis.js", "../js/index.html", "../js/infos.js", "../js/jquery.js", "../js/js_funcs.php", "../js/login.js",
	"../js/packen.js", "../js/register.js", "../js/systembase.js", "../js/teilnehmerv.js",
	"familien.js", "funcs.php", "js_funcs.php", "index.php", "leer.js", "login.js", "password.js",
	"scripts.js", "style.css", "teilnehmer.js",
	"imgs/1.png", "imgs/2.png", "imgs/3.png", "imgs/4.png", "imgs/5.png", "imgs/6.png", "imgs/arrowup.png", "imgs/haken.gif",
	"imgs/x.gif", "imgs/trash.png", "imgs/index.html",
	"js/jquery.js", "js/jquery_ui.js", "js/jquery_ui.css", "js/index.html",
	"js/images/ui-bg_diagonals-thick_18_b81900_40x40.png", "js/images/ui-bg_diagonals-thick_20_666666_40x40.png",
	"js/images/ui-bg_flat_10_000000_40x100.png", "js/images/ui-bg_glass_65_ffffff_1x400.png", "js/images/ui-bg_glass_100_f6f6f6_1x400.png",
	"js/images/ui-bg_glass_100_fdf5ce_1x400.png", "js/images/ui-bg_gloss-wave_35_f6a828_500x100.png", "js/images/ui-bg_highlight-soft_75_ffe45c_1x100.png",
	"js/images/ui-bg_highlight-soft_100_eeeeee_1x100.png", "js/images/ui-icons_228ef1_256x240.png", "js/images/ui-icons_222222_256x240.png",
	"js/images/ui-icons_ef8c08_256x240.png", "js/images/ui-icons_ffd27a_256x240.png", "js/images/ui-icons_ffffff_256x240.png", "js/images/index.html");
	
	// MySQL Tabellen
	$check_tables = array("anm_system" => 6, "anm_gemeinde" => 5, "anm_teilis" => 14);
	
	
	// Ausgabetext ausgeben
	echo 'Installation &uuml;berpr&uuml;fen%!%leer.js.js%!%<b>Dateisystem:</b><br>' .
	'Alle Ordner vorhanden: ';
	
	// Ordnervollstaendigkeit pruefen
	foreach ($check_ordner as $value) {
		if (is_dir($value))
			$ok++;
		else {
			$fail++;
			$failrecord = $failrecord . '<br><b>Dateisystem:</b> "' . $value . '" (Ordner) fehlt.';
		}
	}
	
	// Alle Ordner vorhanden?
	if ($ok == count($check_ordner) && $fail == "")
		echo '<b><font color="green">Ja</font></b><br>';
	else
		echo '<b><font color="red">Nein</font></b> (' . $fail . ' Fehler)<br>';
	$fail = "";
	$ok = "";
	
	// Und weiter geht es mit der Liste:
	echo 'Alle Dateien vorhanden: ';
	
	// Dateivollstaendigkeit pruefen:
	foreach ($check_dateien as $value) {
		if (file_exists($value))
			$ok++;
		else {
			$fail++;
			$failrecord = $failrecord . '<br><b>Dateisystem:</b> "' . $value . '" (Datei) fehlt.';
		}
	}
	
	// Alle Dateien vorhanden?
	if (count($check_dateien) == $ok)
		echo '<b><font color="green">Ja</font></b><br>';
	else
		echo '<b><font color="red">Nein</font></b> (' . $fail . ' Fehler)<br>';
	$ok = "";
	$fail = "";
	
	// Ausgabe, ob zusaetzliche Dateien vorhanden sind:
	echo 'Zus&auml;tzliche Dateien im System: ';
	
	// Alle Ordner durchgehen und mit Dateien-Array abgleichen:
	foreach ($check_ordner as $value) {
		
		$zwischen = @scandir($value);
		// Fuer jeden Eintrag im Verzeichnis muss ein Eintrag im Dateien-Array sein:
		foreach ($zwischen as $value_1) {
			if (!in_array($value . '/' . $value_1, $check_dateien) && !in_array($value . '/' . $value_1, $check_ordner)
			&& $value_1 != "." && $value_1 != "..") {
				$fail++;
				$failrecord = $failrecord . '<br><b>Dateisystem:</b> "' . $value . '/' . $value_1 . '" sollte nicht vorhanden sein!';
			}
		}
		
	}
	
	if ($fail == "")
		echo '<b><font color="green">Nein</font></b><br>';
	else
		echo '<b><font color="red">Ja</font></b> (' . $fail . ' Fehler)<br>';
	$ok = "";
	$fail = "";
	
	// Nun dann mal sehen, ob alle Dateien lesbar sind:
	echo 'Dateien haben Leseberechtigung: ';
	
	foreach ($check_dateien as $value) {
		
		if (is_readable($value))
			$ok++;
		else {
			$fail++;
			$failrecord = $failrecord . '<br><b>Dateisystem:</b> "' . $value . '" ohne Leseberechtigung.';
		}
		
	}
	
	// Sind alle Dateien lesbar?
	if ($fail == "")
		echo '<b><font color="green">Ja</font></b><br>';
	else
		echo '<b><font color="red">Nein</font></b> (' . $fail . ' Fehler)<br>';
	$fail = "";
	$ok = "";
	
	// Weiter mit der SQL Datenbank
	echo '<br><b>MySQL-Datenbank: </b><br>' .
	'MySQL-Datenbank erreichbar: ';
	
	// MySQL erreichbar?
	if (check_install())
		echo '<b><font color="green">Ja</font></b><br>';
	else {
		echo '<b><font color="red">Nein</font></b><br>';
		$failrecord = $failrecord . '<br><b>MySQL:</b>: Keine Verbindung m&ouml;glich. ("' . mysqli_error($verbindung) . '")';
	}
	
	
	// Die Anzahl der Spalten und der Tabellen muss richtig sein:
	foreach ($check_tables as $value => $numbers) {
		
		$sql = mysqli_query($verbindung, "SELECT * FROM " . $value . " LIMIT 0");
		$nummer = mysqli_num_fields($sql);
		
		if ($nummer != $numbers) {
			$fail++;
			$failrecord = $failrecord . '<br><b>MySQL:</b> Tabelle "' . $value . '" fehlerhaft. (' . $nummer
			. ' statt ' . $numbers . ' Spalten)';
		}
		
	}
	
	// Das Ergebnis der MySQL-Prfung ausgeben:
	echo 'Tabellen vollst&auml;ndig: ';
	if ($fail == "")
		echo '<b><font color="green">Ja</font></b>';
	else
		echo '<b><font color="red">Nein</font></b> (' . $fail . ' Fehler)</b>';
	$fail = "";
	
	
	// Hat die Systemtabelle die Reihe 1 und ist es die einzige und existiert sie?
	// Zuerst Abfrage starten
	$sql = mysqli_query($verbindung, "SELECT * FROM anm_system");
	
	while ($row = mysqli_fetch_object($sql)) {
		
		$anzahl++;
		$id = $row->id;
		
		// Fuer den naechsten Test Daten sammeln:
		$register = $row->register;
		$gesperrt = $row->gesperrt;
		$pwd = $row->pwd;
		
	}
	
	// Ist die Reihe alleine?
	if ($anzahl < 1) {
		$fail++;
		$failrecord = $failrecord . '<br>MySQL:</b> Systemtabelle hat keine Werte!';
	}
	elseif ($anzahl > 1) {
		$fail++;
		$failrecord = $failrecord . '<br><b>MySQL:</b> Es gibt mehrere Reihen!';
	}
	// Hat die Systemreihe die ID 1?
	if ($id != "1") {
		$fail++;
		$failrecord = $failrecord . '<br><b>MySQL:</b> Die Systemreihe hat nicht die ID 1!';
	}
	
	// Auswerten vom Systemreihen Check:
	echo '<br>Systemreihencheck: ';
	if ($fail == "")
		echo '<b><font color="green">OK</font></b>';
	else
		echo '<b><font color="red">Fehlerhaft</font></b> (' . $fail . ' Fehler)';
	
	$fail = "";
	
	// Kontrolle der Einstellungen:
	if ($gesperrt == "1") {
		$fail++;
		$failrecord = $failrecord . '<br><b>Sonstiges:</b> Das Portal ist gesperrt!';
	}
	if ($pwd == "" || $pwd == "d41d8cd98f00b204e9800998ecf8427e") {
		$fail++;
		$failrecord = $failrecord . '<br><b>Sonstiges:</b> Das Passwort ist fehlerhaft!';
	}
	
	echo '<br><br><b>Sonstiges:</b><br>Einstellungscheck: ';
	if ($fail == "")
		echo '<b><font color="green">OK</font></b>';
	else
		echo '<b><font color="red">Fehlerhaft</font></b> (' . $fail . ' Fehler)';
	
	// Ausgabe, wenn Registration gesperrt ist:
	if ($register == "0")
		echo ' <font color="orange">(Registration gesperrt)</font>';
	
	
	
	// Der Schluss mit der Fehlerkonsole:
	if ($failrecord != "")
		echo '<br><br><div class="ui-state-error ui-corner-all" style="padding: 20px;"><span class="ui-icon ui-icon-alert icon_in"></span>' .
		'Die Installations&uuml;berpr&uuml;fung hat diese Fehler gefunden:' . $failrecord . '</div>';
	else
		echo '<div id="highlight" class="ui-state-highlight ui-corner-all"><span class="ui-icon ui-icon-info icon_in"></span>' .
		'Das System ist vollst&auml;ndig funktionsf&auml;hig.</div>';
	
}


function familien_teilnehmer () {
	global $verbindung;
	// Empfangen der ID:
	$id = $_POST["id"];
	
	// Auslesen der Daten
	$sql = mysqli_query($verbindung, "SELECT vorname, nachname FROM anm_teilis WHERE familie = '" . $id . "'");
	
	// Absenden der Namen einer Familiengruppe
	while ($row = mysqli_fetch_object($sql)) {
		
		echo $row->vorname . ' ' . $row->nachname . '<br>';
		
	}
	
}

function familien () {
	global $verbindung;
	// Tabellenkopfausgabe
	echo 'Familiengruppen%!%familien.js%!%' .
	'<center><table border="1" style="border-collapse: collapse;">' .
	'<tr>' .
	'<th class="tabelle">Familiengruppe</th>' .
	'<th class="tabelle">Teilnehmeranzahl</th>' .
	'<th class="tabelle">Anzahl Vegetarier</th>' .
	'<th class="tabelle">Anzahl Gottesdienstbesucher</th>' .
	'<th class="tabelle">Anzahl Unterschriften</th>' .
	'<th class="tabelle">Anzahl Bezahlt</th>' .
	'</tr>';
	
	// Datenbankabfrage
	$sql = mysqli_query($verbindung, "SELECT familie, vegetarier, godi, unterschrift, bezahlt FROM anm_teilis ORDER BY familie");
	while ($row = mysqli_fetch_object($sql)) {
		
		// Teilnehmeranzahl addieren
		$sammel[$row->familie]["teilnehmer"]++;
		
		// Wenn Benutzer Vegetarier ist:
		if ($row->vegetarier == "1")
			$sammel[$row->familie]["vegetarier"]++;
		
		// Wenn Benutzer Gottesdienstbesucher ist:
		if ($row->godi == "1")
			$sammel[$row->familie]["godi"]++;
		
		// Wenn Benutzer eine Unterschrift abgegeben hat:
		if ($row->unterschrift == "1")
			$sammel[$row->familie]["unterschrift"]++;
		
		// Wenn Benutzer Bezahlt hat:
		if ($row->bezahlt == "1")
			$sammel[$row->familie]["bezahlt"]++;
		
	}
	
	// Hier nun die Ausgabe der Familiengruppen
	foreach ($sammel as $key => $var) {
		
		// Wenn Familiengruppe im Bereich liegt:
		if ($key < 7 && $key > 0)
			$familie = '<img src="imgs/' . $key . '.png" alt="' . $key . '" height="30px">';
		else
			$familie = 'Keine Familie<br>(' . $key . ')';
		
		// Ausgabe der Reihe fuer Familiengruppe:
		echo '<tr><td class="tabelle1">' . $familie . '</td>' .
		'<td class="tabelle1"><a href="#" onclick="infos(\'' . $key . '\');">' . $var["teilnehmer"] . '</a></td>' .
		'<td class="tabelle1">' . $var["vegetarier"] . '</td>' .
		'<td class="tabelle1">' . $var["godi"] . '</td>' .
		'<td class="tabelle1">' . $var["unterschrift"] . '</td>' .
		'<td class="tabelle1">' . $var["bezahlt"] . '</td></tr>';
		
	}
	
	// Endausgabe
	echo '</table></center>';
	
}


function manual () {
	
	echo 'Bedienungsanleitung%!%leer.js%!%Du kannst hier die Bedienungsanleitung f&uuml;r das komplette' .
	'T&Uuml; Anmeldesystem herunterladen.<br>' .
	'<a href="../downloads/anleitung_administration.pdf" target="_blank">Download <b>(Nur f&uuml;r Administration!)</b></a>';
	
}


function password () {
	global $verbindung;
	// Definieren der POST-Variablen
	$oldpwd = $_POST["oldpwd"];
	$newpwd = $_POST["newpwd"];
	
	if (!empty($newpwd) && !empty($oldpwd)) {
		
		// Altes Passwort cryptieren
		$oldpwd = md5($oldpwd);
		
		// Altes Kennwort auslesen und vergleichen
		$sql = mysqli_query($verbindung, "SELECT pwd FROM anm_system WHERE id = '1' LIMIT 1");
		$row = mysqli_fetch_object($sql);
		
		// Kontrolle, ob das alte Passwort richtig ist
		if ($row->pwd == $oldpwd)
			mysqli_query($verbindung, "UPDATE anm_system SET pwd = '" . md5($newpwd) . "' WHERE id = '1' LIMIT 1");
		
		else
			echo 'error';
		
	}
	
	else {
		
		// Ausgabe vom Formular
		echo 'Passwort &auml;ndern%!%password.js%!%<center><input type="password" class="eingabefeld ' .
		'ui-corner-all" placeholder="Altes Kennwort" id="old"><input type="password" class="eingabefeld ' .
		'ui-corner-all" placeholder="Neues Kennwort" id="new1"><input type="password" class="eingabefeld ' .
		'ui-corner-all" placeholder="Neues Kennwort wiederholen" id="new2"><br>' .
		'<button id="butts">Neues Kennwort speichern</button></center>%!%1';
		
	}
	
}


function teilnehmer_remove () {
	global $verbindung;
	$tid = $_POST["tid"];
	
	// Kontrolle der Teilnehmer ID
	if (is_numeric($tid) && !empty($tid))
		mysqli_query($verbindung, "DELETE FROM anm_teilis WHERE id = '" . $tid . "' LIMIT 1");
	
	else
		echo 'error';
	
}


function teilnehmer_notice () {
	global $verbindung;
	// Ueberpruefung der ID des Teilnehmers:
	$tid = $_POST["tid"];
	if (is_numeric($tid) && !empty($tid)) {
		
		// Nun der Download des Kommentars
		$sql = mysqli_query($verbindung, "SELECT bemerkung, vorname, nachname FROM anm_teilis WHERE id = '" . $tid . "' LIMIT 1");
		$row = mysqli_fetch_object($sql);
		
		if (empty($row->bemerkung))
			echo 'error';
		else
			echo '<b>Bemerkung f&uuml;r ' . $row->vorname . ' ' . $row->nachname
			. '</b><br><br>' . nl2br($row->bemerkung);
		
	}
	else
		echo 'error';
	
}


function teilnehmer_sign () {
	global $verbindung;
	$tid = $_POST["tid"];
	
	// Kontrolle der ID
	if (is_numeric($tid) && !empty($tid)) {
		
		mysqli_query($verbindung, "UPDATE anm_teilis SET unterschrift = '1' WHERE id = '" . $tid . "' LIMIT 1");
		echo 'OK';
		
	}
	
}


function teilnehmer_paid () {
	global $verbindung;
	$tid = $_POST["tid"];
	
	// Kontrolle der ID des Teilnehmers
	if (is_numeric($tid) && !empty($tid)) {
		
		// Abspeichern des neuen Teilnehmers und seiner ID
		mysqli_query($verbindung, "UPDATE anm_teilis SET bezahlt = '1' WHERE id = '" . $tid . "' LIMIT 1");
		echo 'OK';
		
	}
	
}


function teilnehmer () {
	global $verbindung;
		// Tabelle auslesen:
		$sql = mysqli_query($verbindung, "SELECT id, vorname, nachname, geburtstag, familie, bemerkung, vegetarier, godi,
		unterschrift, bezahlt, geschwister, gemeinde FROM anm_teilis ORDER BY nachname");
		
		// Nun den Echo mit Titel und Script machen:
		echo 'Teilnehmer%!%teilnehmer.js%!%' .
		'<center><table border="1" style="border-collapse: collapse;">' .
		'<tr><th style="width: 200px;" class="tabelle">Name</th>' .
		'<th class="tabelle">Geburtstag (Alter)</th>' .
		'<th class="tabelle">Familie</th>' .
		'<th class="tabelle">Bemerkung</th>' .
		'<th class="tabelle">Vegetarier</th>' .
		'<th class="tabelle">GoDi</th>' .
		'<th class="tabelle">Geschwister</th>' .
		'<th class="tabelle">Unterschrift</th>' .
		'<th class="tabelle">Bezahlt</th>' .
		'<th class="tabelle">L&ouml;schen</th></tr>';
		
		// Die Daten in die Tabelle eintragen
		while ($row = mysqli_fetch_object($sql)) {
			
			// Das Alter feststellen:
			$alter = get_age($row->geburtstag);
			
			// Die Familie aussuchen
			if ($row->familie < 1 || $row->familie > 6)
				$familie = 'Keine Familie (' . $row->familie . ')';
			else
				$familie = '<center><img src="imgs/' . $row->familie . '.png" alt="' . $row->familie . '" height="30px"></center>';
			
			// Wenn Ein Kommentar vorhanden ist:
			if ($row->bemerkung != "")
				$bemerkung = '<a href="#" onclick="get_notice(' . $row->id . ')"><img src="imgs/arrowup.png" alt="Anzeigen"></a>';
			else
				$bemerkung = '<img src="imgs/x.gif" alt="Keine Bemerkung">';
			
			// Vegetarier
			if ($row->vegetarier == "1")
				$vegetarier = '<img src="imgs/haken.gif" alt="Ja">';
			else
				$vegetarier = '<img src="imgs/x.gif" alt="Nein">';
			
			// GoDi
			if ($row->godi == "1")
				$godi = '<img src="imgs/haken.gif" alt="Ja">';
			else
				$godi = '<img src="imgs/x.gif" alt="Nein">';
			
			// Geschwister
			if ($row->geschwister == "1")
				$geschwister = '<img src="imgs/haken.gif" alt="Ja">';
			else
				$geschwister = '<img src="imgs/x.gif" alt="Nein">';
			
			// Bezahlt
			if ($row->bezahlt == "1")
				$bezahlt = '<img src="imgs/haken.gif" alt="Ja">';
			else
				$bezahlt = '<a href="#" onclick="pay_it(' . $row->id
				. ')"><img src="imgs/x.gif" alt="Nein" id="paid_' . $row->id . '"></a>';
			
			// Unterschrift
			if ($row->unterschrift == "1")
				$unterschrift = '<img src="imgs/haken.gif" alt="Ja">';
			else
				$unterschrift = '<a href="#" onclick="sign_it(' . $row->id
				. ')"><img src="imgs/x.gif" alt="Nein" id="signed_' . $row->id . '"></a>';
			
			// Ausgabestring:
			echo '<tr><td class="tabelle">' . $row->vorname . ' ' . $row->nachname . '</td>' .
			'<td class="tabelle">' . $row->geburtstag . ' (' . $alter . ')</td>' .
			'<td class="tabelle">' . $familie . '</td>' .
			'<td class="tabelle1">' . $bemerkung . '</td>' .
			'<td class="tabelle1">' . $vegetarier . '</td>' .
			'<td class="tabelle1">' . $godi . '</td>' .
			'<td class="tabelle1">' . $geschwister . '</td>' .
			'<td class="tabelle1">' . $unterschrift . '</td>' .
			'<td class="tabelle1">' . $bezahlt . '</td>' .
			'<td class="tabelle1"><a href="#" onclick="remove(' . $row->id . ', \''
			. $row->vorname . '\', \'' . $row->nachname . '\');"><img src="imgs/trash.png" alt="Loeschen"></a></td></tr>';
			
		}
		
		echo '</table></center>';
	
}


function startseite () {
	// Nur die Ausgabe fuer die Startseite
	echo 'Startseite%!%leer.js%!%<div id="highlight" class="ui-state-highlight ui-corner-all"><span class="ui-icon ui-icon-info icon_in"></span>' .
	'Vorsicht: Diese Seite ist sinnlos!!</div>' .
	'Sie befinden sich nun auf der Startseite vom User Interface des Anmeldesystems.<br><br>' .
	'Du magst dich fragen, was es f&uuml;r eine Funktion hat: Nun es hat keine.<br>' .
	'Ich habe auch lange &uuml;berlegt, was man mit einer solchen Startseite machen k&ouml;nnte und habe leider nichts gefunden...';
}


function login () {
	
	$pwd = $_POST["pwd"];
	// Kontrolle, ob das PWD da ist:
	if ($pwd != "") {
		
		if (md5($pwd) == $GLOBALS["system"]["pwd"]) {
			
			// Erfolgreiche Kontrolle
			echo 'Super';
			$_SESSION["anm_ui"]["allowed"] = "2";
			
		}
		else
			echo 'error';
		
	}
	else
		echo 'error';
	
}


?>
