<?php
/*
Variablenverzeichnis (Global):

- $GLOBALS["script"]
- $GLOBALS["echo"]
- $_SESSION["anm"] = {id, lvl}
- $GLOBALS["system"] = array{name, pwd, register, gesperrt}
*/

// This belongs to the installation-manager:
if (!file_exists('data_inc.php'))
	header('Location: install/index.php');
elseif (file_exists('install/index.php'))
	die('Install directory not deleted yet.');

// Als erstes natuerlich die Session erneuern
session_start();


// Include Dateien hier:
include "mysql_inc.php";
include "functions_inc.php";
include "oof_inc.php";


// Hier nun Kontrolle, ob eingeloggt oder nicht
if ($_SESSION["anm"]["id"] == "" && $_COOKIE["anm_id"] != "" && $_COOKIE["anm_pwd"] != "") {
	
	// Wenn nicht eingeloggt, aber Cookies verfuegbar, dann loginkontrolle
	if (user_login_id($_COOKIE["anm_id"], $_COOKIE["anm_pwd"])) {
		// Hier nun die Cookies auf die Session uebertragen:
		$_SESSION["anm"]["id"] = $_COOKIE["anm_id"];
		$_SESSION["anm"]["lvl"] = "2";
	}
	
	else {
		// Wenn Cookies nicht OK, dann werden sie entfernt:
		setcookie("anm_id", "", time() - 3600, '/');
		setcookie("anm_pwd", "", time() - 3600, '/');
	}
	
}


// Nun die Funktion, die die Links und die Funktionen verwalten soll
// Jeder Link ist in einem Array, der folgendermassen aufgebaut ist:
// array(Funktionsname, Anzeigename, Benutzerebene*, Linkanzeige**)
// * 0 = Alle; 1 = Besucher; 2 = Teilnehmer; 3 = Admin;
// ** 0 = Aus; 1 = An;
$funcs = array(
array("start", "Startseite", "0", "1"),
array("gems", "Gemeindeverzeichnis", "1", "1"),
array("login", "Einloggen", "1", "1"),
array("admin", "Administrator", "1", "0"),
array("teils", "Teilnehmerliste", "2", "1"),
array("daten", "Meine Daten", "2", "1"),
array("packen", "Packliste", "2", "1"),
array("downloads", "Downloads", "2", "1"),
array("logout", "Ausloggen", "2", "1"),
array("systembase", "Basiseinstellungen", "3", "1"),
array("gemeinde", "Gemeinden", "3", "1"),
array("teilnehmerver", "Teilnehmerverwaltung", "3", "1"),
array("info", "Informationen", "3", "1"),
array("anmui", "Anmeldeinterface", "3", "1"),
array("logout", "Ausloggen", "3", "1"),
);


// Wenn downloads oeffentlich sein soll:
if ($GLOBALS["system"]["downloads"] == "1")
	$funcs[] = array("downloads", "Downloads", "1", "1");

// Und dann kommt das Anmelden, wenn es das System erlaubt
if ($GLOBALS["system"]["register"] == "1") {
	$funcs[] = array("register", "Anmelden", "1", "1");
}




// Hier werden nun die Links erzeugt.
$allowed = array();
$value = array();
foreach ($funcs as $value) {
	$ok = "";
	
	// Qualifikationsueberpruefung
	// Fuer alle zuganglich
	if ($value[2] == "0")
		$ok = "1";
	// Gaestequalifikation
	elseif ($value[2] == "1" && $_SESSION["anm"]["id"] == "") {
		$ok = "1";
	}
	// Der Rest
	elseif ($value[2] == $_SESSION["anm"]["lvl"]) {
		$ok = "1";
	}
	
	if ($ok == "1") {
		// Linkerzeugung, nachdem es auch sicher als Link angezeigt werden soll.
		if ($value[3] == "1") {
			$links = $links . '<li type="square"><span class="text"><a href="index.php?action='
			. $value[0] . '">' . $value[1] . '</a></span></li>';
		}
		
		// Die erlaubten Funktionen hier festlegen
		$allowed[] = $value[0];
	}
}


// Nun checken, ob eine Aktion aufgerufen werden soll.
if (isset($_GET["action"])) {
	$action = $_GET["action"];
}
else {
	// Wenn es keine definierte gibt, dann soll die Startseite angezeigt werden.
	$action = "start";
}

if (in_array($action, $allowed)) {
	// Nach Check die gewuenschte Funktion aufrufen
	call_user_func($action);
}
else {
	// Ansonsten Error-Funktion
	call_user_func("error");
}


// Wenn gesperrt, dann dauerhaft Fehlertext:
if ($GLOBALS["system"]["gesperrt"] == "1") {
	$GLOBALS["echo"] = 'Die Seite wurde f&uuml;r Wartungsarbeiten gesperrt.';
}


// Nun die Verbindung zu MySQL auch wieder schlieen:
mysqli_close($verbindung);

?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title><?php
echo $GLOBALS["system"]["name"];
?></title>
<link rel="stylesheet" href="styles.css" type="text/css">
<meta name="description"     content="Anmeldung zur TU 2013.">
<meta name="keywords"        content="TU, 2013, Anmeldung, Teenies, Meppen">
<meta name="author"          content="Jonathan Lusky, jon-lusky@ewetel.net">
<meta name="DC.Publisher"    content="Jonathan Lusky, jon-lusky@ewetel.net">
<meta name="DC.Date"         content="2012-08-31T05:08:52+02:00">
<!-- Zeitstempel Beispiel: 31.12.2001, 08:00 Uhr, +1 Std. zu Greenwich -->
<meta name="DC.Language"     content="de"> <!-- de = deutschsprachig -->
<script src="js/jquery.js" type="text/javascript"></script><?php

// Wenn ein Skript aufgerufen werden soll, dann wird es auch vom Pfad js/ gezogen
if ($GLOBALS["script"] != "") {
	echo '<script src="js/' . $GLOBALS["script"] . '" type="text/javascript"></script>';
}

?></head>


<body bgcolor="#ffffff" alink="#FF9933" background="img/bg.jpg" class="sb">
<div style="position:absolute; top:0px; left:0px;">

<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td align="left">
<img src="img/ecke.jpg" width="38" height="56" alt="">
</td>
<td valign="top" align="left">
<br>
<span class="head">
<?php

echo $GLOBALS["system"]["name"];

?>
</span>
</td>
</tr>
</table>


<!--||| Anfang Tabelle mit Inhalt |||-->
<table border="0" cellspacing="0" cellpadding="15">
<tr>
<td valign="top" width="160" nowrap="nowrap">
<br>
<!--||| Anfang Menpunkte, hier die Namen und Links anpassen |||-->
<ul>
<?php
echo $links;
?>
</ul>

<!--||| Ende Menpunkte, hier ist Platz fr weitere Links oder Grafiken, die aber nicht breiter als 130 Pixel sein drfen. |||-->

</td>

<!--||| Anfang  Textspalte |||-->
<td valign="top" width="400">
<br>
<p align="justify">

<!--||| Hier berschrift und gewnschten Text einfgen. |||-->
<span class="lesen"><?php
// Deklaration fuer Zentralausgabe ECHO
echo $GLOBALS["echo"];
?>
<!--||| Ende Text |||--></span>

</p>
<br>
</td>
<!--||| Ende  Textspalte |||-->

</tr>
</table>
<!--||| Ende Tabelle mit Inhalt |||-->


<!--||| Anfang Tabelle mit Footer |||-->
<table border="0" cellspacing="0" cellpadding="15">
<tr>
<td valign="top" width="160" nowrap="nowrap">&nbsp;</td>
<td align="center" width="400">
<span class="text">

<!--||| Hier die eigene E-Mailadresse einfgen. |||-->
Anmeldesystem f&uuml;r die T&Uuml; 2013 &middot;
<a href="mailto:jon-lusky@ewetel.net"><img src="img/email.jpg"
width="34" height="28" border="0" alt="E-Mail"></a> &middot;
V 1.2

</span>
</td>
</tr>
</table>
<!--||| Ende Tabelle mit Footer |||-->

</div>
</body>
</html>
