<?php

/*
Funktionsbeschreibung: Ersatz fuer die PHP-Funktion htmlentities()
Eingabe: Zu ersetzende String
Ausgabe: Replacter String
*/
function spezialzeichen ($string) {
	
	// Der Needle wird hier beschrieben (Alle gesuchten Zeichen, die ersetzt werden sollen
	$suchen = array("ä", "ü", "ö", "Ä", "Ü", "Ö", "ß", "<", ">");
	
	// Hier der Wert zum Ersetzen
	$ersetzen = array("&auml;", "&uuml;", "&ouml;", "&Auml;", "&Uuml;", "&Ouml;", "&szlig;");
	
	// Und noch einmal alles replacen :)
	$ausgabe_string = str_replace($suchen, $ersetzen, $string);
	
	return $ausgabe_string;
	
}

/*
Funktionsbeschreibung: Zugangsdaten mit Namen und Passwort kontrollieren
Eingabe: Vorname, Nachname, MD5(Passwort)
Ausgabe: false (Keine Daten), ID (Erfolgreich)
*/
function user_login_name ($vorname, $nachname, $pwd) {
	global $verbindung;
	// Erst die Daten lesen
	$sql = mysqli_query($verbindung, "SELECT id, pwd FROM anm_teilis WHERE vorname = '" . $vorname . "'
	AND nachname = '" . $nachname . "' LIMIT 1");
	$row = mysqli_fetch_object($sql);
	
	// Hier nun Passwortkontrolle:
	if ($row->pwd == $pwd) {
		// Hier nun die ID rueckgeben:
		return $row->id;
	}
	
	else {
		// Kein Login
		return false;
	}
	
}




/*
Funktionsbeschreibung: Kontrolliert Zugangsdaten mit ID und bereits verschluesseltem pwd
Eingabe: NutzerID, MD5(Passwort)
Ausgabe: true (Nutzer ist richtig); false (Nutzer ist kein Nutzer)
*/
function user_login_id ($id, $pwd) {
	global $verbindung;
	// Kontrolle, dass beide besetzt sind:
	if ($id == "" || $pwd == "") {
		return false;
	}
	
	else {
		
		// Wenn beide besetzt sind, dann die SQL-Abfrage
		$sql = mysqli_query($verbindung, "SELECT pwd FROM anm_teilis WHERE id = '" . $id . "' LIMIT 1");
		$row = mysqli_fetch_object($sql);
		
		// Nun die Passwortkontrolle:
		if ($row->pwd == $pwd) {
			return true;
		}
		else {
			return false;
		}
		
	}
	
}




/*
Funktionsbeschreibung: Gibt den Namen einer Gemeinde anhand ihrer ID heraus
Eingabe: ID der Gemeinde
Ausgabe: false (Kein Kirchengaenger); Namen der Gemeinde
*/
function church_name ($id) {
	global $verbindung;
	// Wenn kein Kirchengaenger
	if ($id == "0") {
		return false;
	}
	
	else {
		
		// Aus Tabelle den Namen der Kirche
		$sql = mysqli_query($verbindung, "SELECT name FROM anm_gemeinde WHERE id = '" . $id . "' LIMIT 1");
		$row = mysqli_fetch_object($sql);
		
		// Und den Namen der Gemeinde ausgeben:
		return $row->name;
		
	}
	
}





/*
Funktionsbeschreibung: Kontrolliert die Laenge des Passwortes
Eingabe: Passwort
Ausgabe: 1 (Passwort ist in Ordnung); 0 (Passwort zu kurz oder zu lang)
*/
function pwd_controll ($passwort) {
	
	// Das Passwort muss mindestens 5 Zeichen enthalten, maximal 20
	if (strlen($passwort) < 5 || strlen($passwort) > 20) {
		return "0";
	}
	
	else {
		return "1";
	}
	
}





/*
Funktionsbeschreibung: Gibt das Alter anhand des Geburtstages heraus.
Eingabe: Geburtstagsdatum: Tag, Monat, Jahr
Ausgabe: Alter in Jahren
*/
function get_age ($tag, $monat, $jahr) {
	
	
	// Den heutigen Tag festlegen.
	$heute_tag = date('j');
	$heute_monat = date('n');
	$heute_jahr = date('Y');
	
	// Die Differenz der Jahre errechnen
	$diff_jahre = $heute_jahr - $jahr;
	
	// Hat noch ein Geburtstag vor sich im Jahr
	if ($heute_monat < $monat) {
		$diff_jahre--;
	}
	// Hat in diesem Monat noch Geburtstag
	elseif ($heute_monat == $monat && $heute_tag <= $tag) {
		$diff_jahre--;
	}
	
	
	return $diff_jahre;
}





/*
Funktionsbeschreibung: Kontrolliert, ob Vorname und Nachname schon gewaehlt wurde.
Eingabe: Vorname, Nachname
Ausgabe: 1 (Es gibt das schon); 0 (Noch nicht vergeben)
*/
function register_name_check ($vorname, $nachname) {
	global $verbindung;
	// Die MySQL Abfrage
	$sql = mysqli_query($verbindung, "SELECT id FROM anm_teilis WHERE vorname = '" . $vorname . "' AND
	nachname = '" . $nachname . "' LIMIT 1");
	$row = mysqli_fetch_object($sql);
	
	// Und die Kontrolle
	if ($row->id != "") {
		$ausgabe = "1";
	}
	else {
		$ausgabe = "0";
	}
	
	// letztlich nur noch abschicken.
	return $ausgabe;
	
}

?>
